﻿using System;
using System.Collections.Generic;
using System.Windows;
using System.Windows.Controls;
using Infragistics.Controls.Charts;
using System.Collections.ObjectModel;

namespace XamDataChart_ShareXAxis
{
    public partial class MainWindow : Window
    {
        public ObservableCollection<TimestampWrapper> Timestamps { get; set; }
        public List<ObservableCollection<ValueWrapper>> Data { get; set; }
        public Random _rand = new Random(1001);

        public MainWindow()
        {
            InitializeComponent();
            DrawSeries();
        }

        void DrawSeries()
        {
            Timestamps = new ObservableCollection<TimestampWrapper>();

            DateTime timestamp = new DateTime(2011, 5, 17);
            TimeSpan timestep = new TimeSpan(0, 1, 0);

            for (int i = 0; i < 100; ++i)
            {
                Timestamps.Add(new TimestampWrapper { Timestamp = timestamp });
                timestamp += timestep;
            }

            // Set up the dataContext for X axis to be bound to
            this.DataContext = Timestamps;

            
            Data = new List<ObservableCollection<ValueWrapper>>();

            for (int i = 0; i < 2; ++i)
            {
                var data = new ObservableCollection<ValueWrapper>();

                for (int j = 0; j < 100; ++j)
                {
                    data.Add(new ValueWrapper() { Value = _rand.NextDouble() });
                }

                Data.Add(data);

                var chartSeries = new LineSeries()
                {
                    XAxis = xamChart.Axes["xAxis"] as CategoryDateTimeXAxis,
                    YAxis = xamChart.Axes["yAxis"] as NumericYAxis,
                    ValueMemberPath = "Value",
                    Thickness = 1,
                    ItemsSource = Data[i],
                    MarkerType = MarkerType.None
                };

                xamChart.Series.Add(chartSeries);
            }
        }
    }


    public class TimestampWrapper
    {
        public DateTime Timestamp { get; set; }
    }

    public class ValueWrapper
    {
        public double Value { get; set; }
    }
}
